import Automerge from 'automerge';
import CodeMirror from 'codemirror';
import { GetText } from './types';
/**
 * Applies CodeMirror changes to an Automerge.Text. This
 * function should be called inside an Automerge.change callback.
 *
 * @param proxy the proxy of the doc containing the text
 * @param getText a function that returns a Text object
 * @param codeMirrorDoc the editor doc
 * @param editorChange the change
 */
export default function updateAutomergeText<D>(proxy: Automerge.Proxy<D>, getText: GetText<D>, codeMirrorDoc: CodeMirror.Doc, editorChange: CodeMirror.EditorChange): void;
