"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Applies CodeMirror changes to an Automerge.Text. This
 * function should be called inside an Automerge.change callback.
 *
 * @param proxy the proxy of the doc containing the text
 * @param getText a function that returns a Text object
 * @param codeMirrorDoc the editor doc
 * @param editorChange the change
 */
function updateAutomergeText(proxy, getText, codeMirrorDoc, editorChange) {
    var text = getText(proxy);
    if (!text)
        return;
    var startPos = codeMirrorDoc.indexFromPos(editorChange.from);
    var removedLines = editorChange.removed || [];
    var addedLines = editorChange.text;
    var removedLength = removedLines.reduce(function (sum, remove) { return sum + remove.length + 1; }, 0) - 1;
    if (removedLength > 0) {
        text.deleteAt(startPos, removedLength);
    }
    var addedText = addedLines.join('\n');
    if (addedText.length > 0) {
        text.insertAt.apply(text, __spread([startPos], addedText.split('')));
    }
}
exports.default = updateAutomergeText;
//# sourceMappingURL=updateAutomergeText.js.map