"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("@storybook/react");
var react_2 = __importDefault(require("react"));
require("codemirror/lib/codemirror.css");
require("codemirror/theme/material.css");
require("./style.css");
var PadComponent_1 = require("../test/react/PadComponent");
var PeerDoc_1 = __importDefault(require("../test/manymerge/PeerDoc"));
var HubDoc_1 = __importDefault(require("../test/manymerge/HubDoc"));
var AutomergeCodeMirror_1 = __importDefault(require("../src/AutomergeCodeMirror"));
react_1.storiesOf('Collaboration', module).add('Multiple CodeMirrors linked to a single Automerge doc', function () {
    var e_1, _a;
    var peerDocById = new Map();
    var hubDoc = new HubDoc_1.default(function (peerId, msg) { return peerDocById.get(peerId).applyMessage(msg); }, function (msg) { return Array.from(peerDocById.values()).forEach(function (peerDoc) { return peerDoc.applyMessage(msg); }); });
    var peerIds = ['Wilma', 'Fred', 'Barney'];
    var _loop_1 = function (peerId) {
        peerDocById.set(peerId, new PeerDoc_1.default(function (msg) { return hubDoc.applyMessage(peerId, msg); }));
    };
    try {
        for (var peerIds_1 = __values(peerIds), peerIds_1_1 = peerIds_1.next(); !peerIds_1_1.done; peerIds_1_1 = peerIds_1.next()) {
            var peerId = peerIds_1_1.value;
            _loop_1(peerId);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (peerIds_1_1 && !peerIds_1_1.done && (_a = peerIds_1.return)) _a.call(peerIds_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return (react_2.default.createElement("div", null,
        react_2.default.createElement("p", null, "Below are three actors - Wilma, Fred and Barney. They each have a Pad with sheets. Each sheet is connected to a CodeMirror editor."),
        react_2.default.createElement("p", null,
            "The source code is at",
            react_2.default.createElement("a", { href: "https://github.com/aslakhellesoy/automerge-codemirror/blob/master/stories/index.stories.tsx" }, "here"),
            "."),
        react_2.default.createElement("div", { className: "pads" }, peerIds.map(function (peerId) {
            var peerDoc = peerDocById.get(peerId);
            return (react_2.default.createElement("div", { key: peerId },
                react_2.default.createElement("h3", null, peerId),
                react_2.default.createElement(PadComponent_1.PadComponent, { peerDoc: peerDoc, automergeCodeMirror: new AutomergeCodeMirror_1.default(peerDoc.change.bind(peerDoc)) })));
        }))));
});
//# sourceMappingURL=index.stories.js.map