"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var manymerge_1 = require("@cucumber/manymerge");
var automerge_1 = __importDefault(require("automerge"));
var PeerDoc = /** @class */ (function () {
    function PeerDoc(sendMsg) {
        this.handlers = new Set();
        this._doc = automerge_1.default.init();
        this.peer = new manymerge_1.Peer(sendMsg);
    }
    Object.defineProperty(PeerDoc.prototype, "doc", {
        get: function () {
            return this._doc;
        },
        enumerable: true,
        configurable: true
    });
    PeerDoc.prototype.applyMessage = function (msg) {
        var e_1, _a;
        var oldDoc = this._doc;
        var newDoc = this.peer.applyMessage(msg, oldDoc);
        if (newDoc) {
            this._doc = newDoc;
            try {
                for (var _b = __values(this.handlers), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var handler = _c.value;
                    handler(oldDoc, newDoc);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    PeerDoc.prototype.change = function (changeFn) {
        var e_2, _a;
        var oldDoc = this._doc;
        this._doc = automerge_1.default.change(this._doc, changeFn);
        try {
            for (var _b = __values(this.handlers), _c = _b.next(); !_c.done; _c = _b.next()) {
                var handler = _c.value;
                handler(oldDoc, this._doc);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        this.peer.notify(this._doc);
    };
    PeerDoc.prototype.subscribe = function (handler) {
        var _this = this;
        this.handlers.add(handler);
        return function () {
            _this.handlers.delete(handler);
        };
    };
    return PeerDoc;
}());
exports.default = PeerDoc;
//# sourceMappingURL=PeerDoc.js.map