"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var automerge_1 = __importDefault(require("automerge"));
var react_1 = __importStar(require("react"));
var codemirror_1 = __importDefault(require("codemirror"));
var AutomergeCodeMirrorComponent_1 = __importDefault(require("../../src/react/AutomergeCodeMirrorComponent"));
var PadComponent = function (_a) {
    var peerDoc = _a.peerDoc, automergeCodeMirror = _a.automergeCodeMirror;
    var _b = __read(react_1.useState(peerDoc.doc), 2), doc = _b[0], setDoc = _b[1];
    react_1.useEffect(function () {
        return peerDoc.subscribe(function (oldDoc, newDoc) {
            automergeCodeMirror.updateCodeMirrors(oldDoc, newDoc);
            setDoc(newDoc);
        });
    }, []);
    function createSheet() {
        peerDoc.change(function (proxy) {
            if (proxy.sheets == undefined)
                proxy.sheets = [];
            proxy.sheets.push(new automerge_1.default.Text(String(proxy.sheets.length)));
        });
    }
    function removeSheet() {
        peerDoc.change(function (proxy) {
            if (proxy.sheets) {
                proxy.sheets.shift();
            }
        });
    }
    function makeCodeMirror(element) {
        return codemirror_1.default(element, {
            viewportMargin: Infinity,
            lineWrapping: true,
            extraKeys: {
                Tab: false,
            },
        });
    }
    return (react_1.default.createElement("div", { className: "pad" },
        react_1.default.createElement("button", { onClick: createSheet }, "New Sheet"),
        react_1.default.createElement("button", { onClick: removeSheet }, "Remove Sheet"),
        (doc.sheets || []).map(function (_, i) {
            function getText(doc) {
                return doc.sheets[i];
            }
            return (react_1.default.createElement("div", { key: i, className: "sheet" },
                react_1.default.createElement(AutomergeCodeMirrorComponent_1.default, { doc: doc, makeCodeMirror: makeCodeMirror, automergeCodeMirror: automergeCodeMirror, getText: getText })));
        })));
};
exports.PadComponent = PadComponent;
//# sourceMappingURL=PadComponent.js.map